// Autogenerated from Pigeon (v3.1.4), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, MapType) {
  MapTypeNormal = 0,
  MapTypeSatellite = 1,
  MapTypeDark = 2,
};

@class LatLng;
@class MapPoi;
@class CameraPosition;

@interface LatLng : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithLatitude:(NSNumber *)latitude
    longitude:(NSNumber *)longitude;
@property(nonatomic, strong) NSNumber * latitude;
@property(nonatomic, strong) NSNumber * longitude;
@end

@interface MapPoi : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithName:(NSString *)name
    position:(LatLng *)position;
@property(nonatomic, copy) NSString * name;
@property(nonatomic, strong) LatLng * position;
@end

@interface CameraPosition : NSObject
+ (instancetype)makeWithBearing:(nullable NSNumber *)bearing
    target:(nullable LatLng *)target
    tilt:(nullable NSNumber *)tilt
    zoom:(nullable NSNumber *)zoom;
@property(nonatomic, strong, nullable) NSNumber * bearing;
@property(nonatomic, strong, nullable) LatLng * target;
@property(nonatomic, strong, nullable) NSNumber * tilt;
@property(nonatomic, strong, nullable) NSNumber * zoom;
@end

/// The codec used by TencentMapSdkApi.
NSObject<FlutterMessageCodec> *TencentMapSdkApiGetCodec(void);

@protocol TencentMapSdkApi
- (void)initSdkIosApiKey:(NSString *)iosApiKey error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void TencentMapSdkApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapSdkApi> *_Nullable api);

/// The codec used by TencentMapApi.
NSObject<FlutterMessageCodec> *TencentMapApiGetCodec(void);

@protocol TencentMapApi
- (void)setMapTypeType:(MapType)type error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setCompassEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setScaleControlsEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setRotateGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setScrollGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setZoomGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setTiltGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setIndoorViewEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setTrafficEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setBuildingsEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)moveCameraPosition:(NSDictionary *)position duration:(NSNumber *)duration error:(FlutterError *_Nullable *_Nonnull)error;
- (void)pauseWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)resumeWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)startWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)stopWithError:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void TencentMapApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapApi> *_Nullable api);

/// The codec used by TencentMapHandler.
NSObject<FlutterMessageCodec> *TencentMapHandlerGetCodec(void);

@interface TencentMapHandler : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onTapLatLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onTapPoiPoi:(MapPoi *)poi completion:(void(^)(NSError *_Nullable))completion;
- (void)onLongPressLatLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onCameraMoveStartedCameraPosition:(CameraPosition *)cameraPosition completion:(void(^)(NSError *_Nullable))completion;
- (void)onCameraMoveCameraPosition:(CameraPosition *)cameraPosition completion:(void(^)(NSError *_Nullable))completion;
- (void)onCameraIdleCameraPosition:(CameraPosition *)cameraPosition completion:(void(^)(NSError *_Nullable))completion;
@end
NS_ASSUME_NONNULL_END
