// Autogenerated from Pigeon (v3.1.4), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import "Pigeon.h"
#import <Flutter/Flutter.h>

#if !__has_feature(objc_arc)
#error File requires ARC to be enabled.
#endif

static NSDictionary<NSString *, id> *wrapResult(id result, FlutterError *error) {
  NSDictionary *errorDict = (NSDictionary *)[NSNull null];
  if (error) {
    errorDict = @{
        @"code": (error.code ?: [NSNull null]),
        @"message": (error.message ?: [NSNull null]),
        @"details": (error.details ?: [NSNull null]),
        };
  }
  return @{
      @"result": (result ?: [NSNull null]),
      @"error": errorDict,
      };
}
static id GetNullableObject(NSDictionary* dict, id key) {
  id result = dict[key];
  return (result == [NSNull null]) ? nil : result;
}
static id GetNullableObjectAtIndex(NSArray* array, NSInteger key) {
  id result = array[key];
  return (result == [NSNull null]) ? nil : result;
}


@interface LatLng ()
+ (LatLng *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface MapPoi ()
+ (MapPoi *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface CameraPosition ()
+ (CameraPosition *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end

@implementation LatLng
+ (instancetype)makeWithLatitude:(NSNumber *)latitude
    longitude:(NSNumber *)longitude {
  LatLng* pigeonResult = [[LatLng alloc] init];
  pigeonResult.latitude = latitude;
  pigeonResult.longitude = longitude;
  return pigeonResult;
}
+ (LatLng *)fromMap:(NSDictionary *)dict {
  LatLng *pigeonResult = [[LatLng alloc] init];
  pigeonResult.latitude = GetNullableObject(dict, @"latitude");
  NSAssert(pigeonResult.latitude != nil, @"");
  pigeonResult.longitude = GetNullableObject(dict, @"longitude");
  NSAssert(pigeonResult.longitude != nil, @"");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return @{
    @"latitude" : (self.latitude ?: [NSNull null]),
    @"longitude" : (self.longitude ?: [NSNull null]),
  };
}
@end

@implementation MapPoi
+ (instancetype)makeWithName:(NSString *)name
    position:(LatLng *)position {
  MapPoi* pigeonResult = [[MapPoi alloc] init];
  pigeonResult.name = name;
  pigeonResult.position = position;
  return pigeonResult;
}
+ (MapPoi *)fromMap:(NSDictionary *)dict {
  MapPoi *pigeonResult = [[MapPoi alloc] init];
  pigeonResult.name = GetNullableObject(dict, @"name");
  NSAssert(pigeonResult.name != nil, @"");
  pigeonResult.position = [LatLng fromMap:GetNullableObject(dict, @"position")];
  NSAssert(pigeonResult.position != nil, @"");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return @{
    @"name" : (self.name ?: [NSNull null]),
    @"position" : (self.position ? [self.position toMap] : [NSNull null]),
  };
}
@end

@implementation CameraPosition
+ (instancetype)makeWithBearing:(nullable NSNumber *)bearing
    target:(nullable LatLng *)target
    tilt:(nullable NSNumber *)tilt
    zoom:(nullable NSNumber *)zoom {
  CameraPosition* pigeonResult = [[CameraPosition alloc] init];
  pigeonResult.bearing = bearing;
  pigeonResult.target = target;
  pigeonResult.tilt = tilt;
  pigeonResult.zoom = zoom;
  return pigeonResult;
}
+ (CameraPosition *)fromMap:(NSDictionary *)dict {
  CameraPosition *pigeonResult = [[CameraPosition alloc] init];
  pigeonResult.bearing = GetNullableObject(dict, @"bearing");
  pigeonResult.target = [LatLng fromMap:GetNullableObject(dict, @"target")];
  pigeonResult.tilt = GetNullableObject(dict, @"tilt");
  pigeonResult.zoom = GetNullableObject(dict, @"zoom");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return @{
    @"bearing" : (self.bearing ?: [NSNull null]),
    @"target" : (self.target ? [self.target toMap] : [NSNull null]),
    @"tilt" : (self.tilt ?: [NSNull null]),
    @"zoom" : (self.zoom ?: [NSNull null]),
  };
}
@end

@interface TencentMapSdkApiCodecReader : FlutterStandardReader
@end
@implementation TencentMapSdkApiCodecReader
@end

@interface TencentMapSdkApiCodecWriter : FlutterStandardWriter
@end
@implementation TencentMapSdkApiCodecWriter
@end

@interface TencentMapSdkApiCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation TencentMapSdkApiCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[TencentMapSdkApiCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[TencentMapSdkApiCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *TencentMapSdkApiGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    TencentMapSdkApiCodecReaderWriter *readerWriter = [[TencentMapSdkApiCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void TencentMapSdkApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapSdkApi> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapSdkApi.initSdk"
        binaryMessenger:binaryMessenger
        codec:TencentMapSdkApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(initSdkIosApiKey:error:)], @"TencentMapSdkApi api (%@) doesn't respond to @selector(initSdkIosApiKey:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_iosApiKey = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api initSdkIosApiKey:arg_iosApiKey error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
@interface TencentMapApiCodecReader : FlutterStandardReader
@end
@implementation TencentMapApiCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [CameraPosition fromMap:[self readValue]];
    
    case 129:     
      return [LatLng fromMap:[self readValue]];
    
    case 130:     
      return [MapPoi fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface TencentMapApiCodecWriter : FlutterStandardWriter
@end
@implementation TencentMapApiCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[CameraPosition class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[LatLng class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[MapPoi class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface TencentMapApiCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation TencentMapApiCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[TencentMapApiCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[TencentMapApiCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *TencentMapApiGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    TencentMapApiCodecReaderWriter *readerWriter = [[TencentMapApiCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void TencentMapApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapApi> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setMapType"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setMapTypeType:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setMapTypeType:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        MapType arg_type = [GetNullableObjectAtIndex(args, 0) integerValue];
        FlutterError *error;
        [api setMapTypeType:arg_type error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setCompassEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setCompassEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setCompassEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setCompassEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setScaleControlsEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setScaleControlsEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setScaleControlsEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setScaleControlsEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setRotateGesturesEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setRotateGesturesEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setRotateGesturesEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setRotateGesturesEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setScrollGesturesEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setScrollGesturesEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setScrollGesturesEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setScrollGesturesEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setZoomGesturesEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setZoomGesturesEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setZoomGesturesEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setZoomGesturesEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setTiltGesturesEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setTiltGesturesEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setTiltGesturesEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setTiltGesturesEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setIndoorViewEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setIndoorViewEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setIndoorViewEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setIndoorViewEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setTrafficEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setTrafficEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setTrafficEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setTrafficEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.setBuildingsEnabled"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(setBuildingsEnabledEnabled:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(setBuildingsEnabledEnabled:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_enabled = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api setBuildingsEnabledEnabled:arg_enabled error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.moveCamera"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(moveCameraPosition:duration:error:)], @"TencentMapApi api (%@) doesn't respond to @selector(moveCameraPosition:duration:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSDictionary *arg_position = GetNullableObjectAtIndex(args, 0);
        NSNumber *arg_duration = GetNullableObjectAtIndex(args, 1);
        FlutterError *error;
        [api moveCameraPosition:arg_position duration:arg_duration error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.pause"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(pauseWithError:)], @"TencentMapApi api (%@) doesn't respond to @selector(pauseWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api pauseWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.resume"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(resumeWithError:)], @"TencentMapApi api (%@) doesn't respond to @selector(resumeWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api resumeWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.start"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(startWithError:)], @"TencentMapApi api (%@) doesn't respond to @selector(startWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api startWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.TencentMapApi.stop"
        binaryMessenger:binaryMessenger
        codec:TencentMapApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(stopWithError:)], @"TencentMapApi api (%@) doesn't respond to @selector(stopWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api stopWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
@interface TencentMapHandlerCodecReader : FlutterStandardReader
@end
@implementation TencentMapHandlerCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [CameraPosition fromMap:[self readValue]];
    
    case 129:     
      return [LatLng fromMap:[self readValue]];
    
    case 130:     
      return [MapPoi fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface TencentMapHandlerCodecWriter : FlutterStandardWriter
@end
@implementation TencentMapHandlerCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[CameraPosition class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[LatLng class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[MapPoi class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface TencentMapHandlerCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation TencentMapHandlerCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[TencentMapHandlerCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[TencentMapHandlerCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *TencentMapHandlerGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    TencentMapHandlerCodecReaderWriter *readerWriter = [[TencentMapHandlerCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


@interface TencentMapHandler ()
@property (nonatomic, strong) NSObject<FlutterBinaryMessenger> *binaryMessenger;
@end

@implementation TencentMapHandler

- (instancetype)initWithBinaryMessenger:(NSObject<FlutterBinaryMessenger> *)binaryMessenger {
  self = [super init];
  if (self) {
    _binaryMessenger = binaryMessenger;
  }
  return self;
}
- (void)onTapLatLng:(LatLng *)arg_latLng completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onTap"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_latLng ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onTapPoiPoi:(MapPoi *)arg_poi completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onTapPoi"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_poi ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onLongPressLatLng:(LatLng *)arg_latLng completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onLongPress"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_latLng ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onCameraMoveStartedCameraPosition:(CameraPosition *)arg_cameraPosition completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onCameraMoveStarted"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_cameraPosition ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onCameraMoveCameraPosition:(CameraPosition *)arg_cameraPosition completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onCameraMove"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_cameraPosition ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onCameraIdleCameraPosition:(CameraPosition *)arg_cameraPosition completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.TencentMapHandler.onCameraIdle"
      binaryMessenger:self.binaryMessenger
      codec:TencentMapHandlerGetCodec()];
  [channel sendMessage:@[arg_cameraPosition ?: [NSNull null]] reply:^(id reply) {
    completion(nil);
  }];
}
@end
